<?php
namespace nulib\schema\types;

use nulib\schema\_scalar\ScalarSchema;
use nulib\schema\Result;
use nulib\schema\Schema;

class trawstring extends _tstring {
  const NAME = "rawstring";

  function getClass(): string {
    return "string";
  }

  function getNullValue() {
    return $this->nullable? null: "";
  }

  function isNull($value): bool {
    return $value === null;
  }

  function isValid($value, ?bool &$normalized=null): bool {
    if (is_string($value)) {
      $normalized = true;
      return true;
    }
    return is_scalar($value);
  }

  function parse(string $value) {
    return $value;
  }

  /**
   * @var ScalarSchema $schema
   */
  function normalize(&$value, Result $result, Schema $schema): bool {
    if ($result->normalized) {
    } elseif (is_string($value)) {
      $result->setNormalized();
    } elseif (is_scalar($value)) {
      $value = strval($value);
      return true;
    }
    return false;
  }

  function format($value, $format=null): string {
    return strval($value);
  }
}
